package com.eactive.eai.agent.transformer;

import com.eactive.eai.agent.command.Command;
import com.eactive.eai.agent.command.CommandException;
import com.eactive.eai.common.util.Logger;
import com.eactive.eai.transformer.function.FunctionManager;

public class RemoveTransformFuncCommand extends Command {
	private static final long serialVersionUID = 1L;

	public RemoveTransformFuncCommand() {
		super("RemoveTransformFuncCommand");
	}

	public Object execute() throws CommandException {
		Logger logger = Logger.getLogger(Logger.LOGGER_DEFAULT);
		if (logger.isInfo())
			logger.info(this.name + " is executed");

		if (!(args instanceof String)) {
			String rspErrorCode = "RECEAIMCM001";
			String msg = makeException(rspErrorCode, null);
			if (logger.isError())
				logger.error(msg);
			throw new CommandException(msg);
		}

		try {
			FunctionManager manager = FunctionManager.getInstance();

			String functionName = (String) args;
			if (functionName != null) {
				manager.remove(functionName);
			}
		} catch (Exception e) {
			String rspErrorCode = "RECEAIMCM002";
			String msg = makeException(rspErrorCode, e);
			if (logger.isError())
				logger.error(msg, e);
			throw new CommandException(msg);
		}
		return "success";

	}

//	   public static void main(String args[]) throws Exception {
//	   test();
//}

// private static void test() throws Exception {
//        
//        FunctionManager manager = FunctionManager.getInstance();
//        
//        Command command = new RemoveTransformFuncCommand();
//        command.setArgs("");
//        AgentUtil.broadcast(command);
//        
//    }
}
